#pragma once

#include <cstdio>
#include "types.h"
#include "resource.h"

namespace hash_nm {

    /**
     * @brief Funcion hash GOST 34.11-2012 (stribog)
     *
     * Esta función hash se encuentra en la última actualización del estándar ruso.
     *
     * @param buf
     * @param size
     * @param mode
     * @return hash
     */
    block512_t hash(char *buf, size_t size, hash_mode_t mode = hm512);

    /**
     * @brief Prepara la tabla para realizar cálculos de la función hash
     *
     * Esta función debe ejecutarse para que se pueda utilizar el algoritmo de hash.
     *
     */
    void precalc_mul_table();

//	#include "hash.hpp"
}
